unit FormMain;
interface
uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls;
  const
   BufferInSize  = 64;
   BufferOutSize = 64;
   type
   TBufferIn = array[0..BufferInSize] of byte;
   TBufferOut = array[0..BufferOutSize] of byte;
   TForm1 = class(TForm)
    Edit1: TEdit;
    SpeedButton1: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
   private
      FBufferOut:TBufferOut;
      FBufferIn:TBufferIn;
      function USBEvent(var Msg: TMessage): Boolean;
   public
   end;
var
  Form1: TForm1;
implementation
uses
   TechnolUSBInterface;
const
   VENDOR_ID           = 31416;
   PRODUCT_ID          = 43805;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
   Label1.Caption:='Interface USB dconnecte';
   Application.HookMainWindow(USBEvent);
   Connect(Application.Handle);
end;
procedure TForm1.FormDestroy(Sender: TObject);
begin
   Application.UnHookMainWindow(USBEvent);
   Disconnect;
end;
procedure TForm1.SpeedButton1Click(Sender: TObject);
var   DevHandle:cardinal;
        i : Integer;
begin
   if edit1.Text= '' Then Exit;
   For i:= 1 to 63 Do
   Begin
      FBufferOut[i]:=$A0;
   End;
   FBufferOut[1]:= $4D;
   For i:= 1 to (Length(Edit1.text))Do
   Begin
      FBufferOut[i+1]:=ord(Edit1.Text[i]);
   End;
   DevHandle := GetHandle(VENDOR_ID, Product_ID);
   Write(DevHandle,@FBufferOut);
end;
function TForm1.USBEvent(var Msg: TMessage): Boolean;
var
   DevHandle:cardinal;
   i:integer;
begin
  if Msg.Msg = WM_HID_EVENT then
  begin
     case Msg.WParam of

        NOTIFY_PLUGGED :
        begin
           
           DevHandle := Msg.LParam;
        
           if (GetVendorID(DevHandle) = VENDOR_ID) and (GetProductID(DevHandle) = PRODUCT_ID) then
           begin
             Label1.Caption:='interface USB connecte';
           end;

        end;
        NOTIFY_UNPLUGGED :
        begin

           DevHandle := Msg.LParam;
           if (GetVendorID(DevHandle) = VENDOR_ID) and (GetProductID(DevHandle) = PRODUCT_ID) then
           begin
             Label1.Caption:='Interface USB dconnecte';
            end;
        end;
        NOTIFY_CHANGED :
        begin
           DevHandle := GetHandle(VENDOR_ID,PRODUCT_ID);
           SetReadNotify(DevHandle,true);
        end;
        NOTIFY_READ :
        begin
           DevHandle := Msg.LParam;

           if (GetVendorID(DevHandle) = VENDOR_ID) and (GetProductID(DevHandle) = PRODUCT_ID) then
           begin
               Read(DevHandle,@FBufferIn);
               label3.Caption :='';
               i:=1;
               while (FBufferIn[i] <> 0) do
                    begin
                      Label3.Caption:= label3.caption + chr(fbufferin[i]);
                      i:=i+1;
                    end;
           end;

        end;

     end;
  end;
end;
procedure TForm1.Button1Click(Sender: TObject);
var   DevHandle:cardinal;
        i : Integer;
begin
   For i:= 1 to 63 Do
   Begin
      FBufferOut[i]:=$A0;
   End;
   FBufferOut[1]:= 65;
   DevHandle := GetHandle(VENDOR_ID, Product_ID);
   Write(DevHandle,@FBufferOut);
end;

procedure TForm1.Button2Click(Sender: TObject);
var   DevHandle:cardinal;
        i : Integer;
begin
   For i:= 1 to 63 Do
   Begin
      FBufferOut[i]:=$A0;
   End;
   FBufferOut[1]:= 66;
   DevHandle := GetHandle(VENDOR_ID, Product_ID);
   Write(DevHandle,@FBufferOut);
end;
procedure TForm1.Button3Click(Sender: TObject);
var   DevHandle:cardinal;
        i : Integer;
begin
   For i:= 1 to 63 Do
   Begin
      FBufferOut[i]:=$A0;
   End;
   FBufferOut[1]:= 67;
   DevHandle := GetHandle(VENDOR_ID, Product_ID);
   Write(DevHandle,@FBufferOut);
end;
procedure TForm1.Button4Click(Sender: TObject);
var   DevHandle:cardinal;
        i : Integer;
begin
   For i:= 1 to 63 Do
   Begin
      FBufferOut[i]:=$A0;
   End;
   FBufferOut[1]:= 68;
   DevHandle := GetHandle(VENDOR_ID, Product_ID);
   Write(DevHandle,@FBufferOut);
end;
end.
